/*

        WAILER.C

        Mailer para Windows.

        (C) Angel Ortega 1992/1993

*/

#include <windows.h>
#include "wailer.h"

/* solucin para saltarse las chapuzas de los compiladores */
#if !defined(__TURBOC__)
	#define K_WNDPROC
#else
	#define K_WNDPROC (WNDPROC)
#endif

/* nombre del programa con versin */
char szApp[]="The Wailer 1.1.3";

#include "waimotor.c"


/*********************
		Globales
**********************/

/* handle al font proporcional */
HANDLE pFont=0;
/* handle al font proporcional fino */
HANDLE tFont=0;
/* handle al font fixed */
HANDLE fFont=0;
/* switch de fonts */
int fontswitch=0;


/************************
        Funciones
************************/


void WriteMensaje(HWND hwnd)
/* escribe un mensaje */
{
		time_t t;
		struct tm * ti;
        int o;
        char tmp[150];
        unsigned int tam;
        HANDLE h;
        char * ptr;
        int i;
        int n, l;

        /* abre el fichero */
        if((o=open(RESP_FILE,O_CREAT|O_BINARY|O_WRONLY,
        	S_IREAD|S_IWRITE))==-1)
                return;

        /* va al final */
        lseek(o,0,SEEK_END);

        /* coge el tamao */
        tam=(unsigned int) SendDlgItemMessage(hwnd, WAI_TEXTO,
                WM_GETTEXTLENGTH, 0, 0L);

        h=LocalAlloc(LMEM_MOVEABLE, tam+16);
        ptr=LocalLock(h);

        SendDlgItemMessage(hwnd, WAI_TEXTO, WM_GETTEXT, tam+1,
                (LONG)(char far *)ptr);

        /* si se quiere la respuesta en ANSI */
        if(!RespuestaANSI)
                AnsiToOem(ptr,ptr);

		/* se buscan tres lneas */
        for(l=0,n=0;l<3 && ptr[n]!=0;n++)
        {
                if(ptr[n]=='\n')
                        l++;
        }

        /* se escribe la cabecera */
        write(o,ptr,n);

		/* se escribe el Message-ID */
		time(&t);
		ti=localtime(&t);
		sprintf(tmp,
		"Message-ID: %s_wailer_%s@crcok_%02d%02d%02d_%02d%02d%02d\r\n", Yo,
			Conferencias[Conferencia], ti->tm_sec, ti->tm_min,
			ti->tm_hour, ti->tm_mday, ti->tm_mon, ti->tm_year);
		write(o,tmp,strlen(tmp));

        /* se escribe la cabecera X */
        sprintf(tmp,"X-Newsreader: %s\r\nX-Tabla: %s\r\n", szApp,
                RespuestaANSI?"ANSI":"DOS");
        write(o,tmp,strlen(tmp));

        /* se cortan las palabras */
        WordWrap(ptr+n);

        /* se escribe el resto */
        write(o,ptr+n,tam-n);

        /* si hay fichero de firma se aade */
        if((i=open(FIRM_FILE,O_RDONLY|O_BINARY))!=-1)
        {
                write(o,ptr,read(i,ptr,32000));
                close(i);
        }

        LocalUnlock(h);
        LocalFree(h);

		sprintf(tmp,"\r\n-- %s\r\n\r\n", szApp);
        write(o, tmp, strlen(tmp));

		WriteTag(o);

        /* lo cierra */
        close(o);
}


#if defined(__TURBOC__)
#pragma argsused
#endif

BOOL FAR PASCAL AcercaDeProc(HWND hDlg, WORD message, WORD wParam, LONG lParam)
/* procedimiento de cuadro de acerca de... */
{
        switch(message)
        {
        case WM_INITDIALOG:
                SetWindowText(hDlg, szApp);
                return(TRUE);

        case WM_COMMAND:
                if(wParam==IDOK)
                {
                        EndDialog(hDlg, 0);
                        return(TRUE);
                }
                break;
        }
        return(FALSE);
}


/** Rutinas de controles del cuadro de conferencias **/

void CtrlConfe(HWND hDlg)
/* actualiza los botones de radio y rellena la lista en consecuencia */
{
        int i;
        unsigned long l;
        char strtmp[25];

        /* escribe el nombre y el nmero de mensajes */
        if((i=open(NUEVOS_IND, O_RDONLY|O_BINARY))!=-1)
        {
                lseek(i,0,2);
                l=(long) tell(i)/sizeof(struct tagind);
                sprintf(strtmp, "Nuevos (%lu)", l);
                close(i);
        }
        else
                strcpy(strtmp, "Nuevos");

        SendDlgItemMessage(hDlg, WAC_NUEVOS, WM_SETTEXT,
                0, (DWORD)(char far *) strtmp);

        if((i=open(HISTO_IND, O_RDONLY|O_BINARY))!=-1)
        {
                lseek(i,0,2);
                l=(long) tell(i)/sizeof(struct tagind);
                sprintf(strtmp, "Histrico (%lu)", l);
                close(i);
        }
        else
                strcpy(strtmp, "Histrico");

        SendDlgItemMessage(hDlg, WAC_HISTORICO, WM_SETTEXT,
                0, (DWORD)(char far *) strtmp);

        /* dibuja los botones de radio */
        SendDlgItemMessage(hDlg, WAC_NUEVOS, BM_SETCHECK, !Histo, 0L);
        SendDlgItemMessage(hDlg, WAC_HISTORICO, BM_SETCHECK, Histo, 0L);
}


BOOL CargaConfes(HWND hDlg)
/* carga en memoria las conferencias */
{
        int n;

        /* vaca la lista */
        SendDlgItemMessage(hDlg, WAC_LISTA, LB_RESETCONTENT, 0, 0L);

        /* carga la lista pertinente */
        if((n=open(CONFE_FILE, O_RDONLY|O_BINARY))!=-1)
        {
                LoadConfes(n);

                close(n);

                /* la rellena */
                for(n=0;n<NumConfes;n++)
                {
                        SendDlgItemMessage(hDlg, WAC_LISTA, LB_ADDSTRING, 0,
                                (LONG) (char far *) Conferencias[n]);
                }

                /* desactiva el OK, porque ahora no hay ninguna seleccionada */
                EnableWindow(GetDlgItem(hDlg, WAC_OK), 0);

                return(TRUE);
        }
        else
        {
                MessageBox(hDlg, "No hay ninguna conferencia cargada!",
                        szApp, MB_OK|MB_ICONSTOP);

                return(FALSE);
        }
}


BOOL FAR PASCAL ConfeProc(HWND hDlg, WORD message, WORD wParam, LONG lParam)
/* procedimiento del cuadro de dilogo */
{
        int n;

        switch(message)
        {
        case WM_INITDIALOG:

                CtrlConfe(hDlg);

                if(CargaConfes(hDlg)==FALSE)
                        EndDialog(hDlg, 0);

                return(TRUE);

        case WM_COMMAND:
                switch(wParam)
                {
                case WAC_LISTA:
                        switch(HIWORD(lParam))
                        {
                        case LBN_DBLCLK:
                                /* si se hace doble click sobre un elemento de la lista,
                                   es como pulsar OK */
                                SendMessage(hDlg, WM_COMMAND, WAC_OK, 0L);

                        case LBN_SELCHANGE:
                                /* si se selecciona alguna, se habilita OK */
                                EnableWindow(GetDlgItem(hDlg, WAC_OK), 1);
                                break;
                        }
                        break;

                case WAC_NUEVOS:
                        /* base de datos nueva */
                        Histo=0;
                        CtrlConfe(hDlg);
                        break;

                case WAC_HISTORICO:
                        /* histrica */
                        Histo=1;
                        CtrlConfe(hDlg);
                        break;

                case WAC_OK:

                        /* seleccin actual */
                        n=(int) SendDlgItemMessage(hDlg, WAC_LISTA, LB_GETCURSEL, 0, 0L);

                        if(n!=LB_ERR)
                                Conferencia=n;
                        else
                                break;

                        EndDialog(hDlg, 1);
                        return(TRUE);

                case WAC_CANCELAR:
                        EndDialog(hDlg, 0);
                        return(TRUE);
                }
        }
        return(FALSE);
}


/** Rutinas de controles de la ventana principal **/

void SetInfo(HWND hwnd)
/* rellena el cuadro info */
{
        char tmp[220];
        char * c;

        if(Conferencia==-1)
                c="<ninguna>";
        else
                c=Conferencias[Conferencia];

        if(Mensaje==NO_MENSAJE)
                sprintf(tmp,"[%s]\nConferencia:\n   %s",
                        Histo?"Histrico":"Nuevos", c);
        else
                sprintf(tmp,"[%s]\nConferencia:\n   %s\nEstado:\n   <%s>\nNmero: %d",
                        Histo?"Histrico":"Nuevos",
                        c, (Msg.dat&MASK_BOR)?"borrado":(Msg.dat&MASK_LEI?"ya ledo":"nuevo"), Msg.num);

    /* define el panel de info */
        SetWindowText(GetDlgItem(hwnd,WAI_INFO), tmp);

        /* pone el texto pertinente al botn de borrado */
        SetWindowText(GetDlgItem(hwnd, WAI_BORRAR),
                (Msg.dat&MASK_BOR)?"Recuperar":"Borrar");

        /* pone la fecha del mensaje */
        if(Fecha[0] && Mensaje!=NO_MENSAJE)
                sprintf(tmp,"Mensaje (%s)",(Fecha+6));
        else
                strcpy(tmp,"Texto del Mensaje");

        if(Mailer[0]!=0)
        {
                strcat(tmp," [");
                strcat(tmp,Mailer);
                strcat(tmp,"]");
        }

        SetWindowText(GetDlgItem(hwnd, WAI_FECHA),tmp);
}


void SetTexto(HWND hwnd)
/* rellena el texto */
{
        HANDLE h;
        LPSTR ptr;
        int c;
        int i;
        int t;
		FILE * f;
        unsigned int n,m;
        unsigned int off;
        unsigned int tmem;

        if(Mensaje==NO_MENSAJE || Escr)
                SetWindowText(GetDlgItem(hwnd, WAI_TEXTO), "");
        else
        {
                /* se abre el ndice */
                if(Histo)
                        i=open(HISTO_IND, O_RDONLY|O_BINARY);
                else
                        i=open(NUEVOS_IND, O_RDONLY|O_BINARY);

                if(i==-1)
                        return;

        /* se abre el temporal, que contiene los offsets reales */
                if((t=open(TMP_FILE, O_RDONLY|O_BINARY))==-1)
                {
                        close(i);
                        return;
                }

                lseek(t, Mensaje*sizeof(int), 0);
                read(t,&off,sizeof(int));
                close(t);

                /* se posiciona */
                lseek(i, off*sizeof(struct tagind), 0);

                /* se lee el tag del mensaje */
                read(i, &Msg, sizeof(Msg));
                close(i);

                /* se abre el fichero de datos */
                if(Histo)
                        f=fopen(HISTO_DAT, "rb");
                else
                        f=fopen(NUEVOS_DAT, "rb");

                if(f==NULL)
                        return;

                /* bsqueda de cadenas en la cabecera */
                Fecha[0]=0;
                Tabla[0]=0;
                Mailer[0]=0;

                fseek(f, Msg.offset, 0);

                while(1)
                {
                        fgets(lineatmp, 149, f);
                        lineatmp[strlen(lineatmp)-1]=0;

                        /* si es la ltima de la cabecera */
                        if(lineatmp[0]==0)
                                break;

                        if(memcmp(lineatmp, "Date: ", 6)==0)
                                strcpy(Fecha, lineatmp);
                        else
                        if(memcmp(lineatmp, "X-Tabla: ", 9)==0)
                                strcpy(Tabla, lineatmp+9);
                        else
                        if(memcmp(lineatmp, "X-Newsreader: ", 14)==0)
                                strcpy(Mailer, lineatmp+14);
                }

                /* se coge el subject */
                fseek(f, (Msg.offset+Msg.offsub), 0);
                fgets(Subject, 80, f);
                SomeToAnsi(Subject, Subject);
                Subject[strlen(Subject)-1]=0;

                /* se coge el remitente */
                fseek(f, (Msg.offset+Msg.offfrom), 0);
                fgets(Xremit, 149, f);
                SomeToAnsi(Xremit, Xremit);
                Xremit[strlen(Xremit)-1]=0;

                for(n=0;Xremit[n]!='@' && Xremit[n]!=0;n++)
                        Remit[n]=Xremit[n];
                Remit[n]=0;

                /* se posiciona */
                fseek(f, (Msg.offset+Msg.tamcab)-1, 0);

                /* se aloca memoria */
                tmem=Msg.tambody+Msg.tambody/4;
                h=GlobalAlloc(GMEM_MOVEABLE, (DWORD) tmem+1);
                ptr=GlobalLock(h);

                /* se aaden \r por cada \n */
                for(n=0,m=0;m<Msg.tambody && n<tmem;n++,m++)
                {
                        c=fgetc(f);

                        if(c=='\n')
                        {
                                ptr[n]='\r';
                                n++;
                        }

                        ptr[n]=(char) c;
                }
                ptr[n]=0;

                fclose(f);

                /* se traduce a Ansi */
                SomeToAnsi(ptr, ptr);

                /* se define el texto */
                SetWindowText(GetDlgItem(hwnd, WAI_TEXTO), ptr);

                /* se libera */
                GlobalUnlock(h);
                GlobalFree(h);
        }

        SetInfo(hwnd);

        /* lo marca como ledo */
        if(Mensaje!=NO_MENSAJE)
                DelMsg(0);
}


void QuoteTexto(HWND hwnd)
/* quotea el texto (con >) */
{
        HWND h;
        DWORD n;
        DWORD l;
        DWORD t;
        char str[1024];
        char tmp[512];
        int ini;
        int lini;
        HCURSOR hc;
        char * ptr;

        /* handler del texto */
        h=GetDlgItem(hwnd, WAI_TEXTO);

        if(memcmp(Subject+1,"Re: ",4)!=0 && memcmp(Subject+1,"RE: ",4)!=0
        && memcmp(Subject+1," RE: ",5)!=0)
        {
                sprintf(tmp," RE: %s", Subject+1);
                strcpy(Subject, tmp);
        }

		if(strcmp(Conferencias[Conferencia],"guest")==0)
			ptr="contactos";
		else
		if(strcmp(Conferencias[Conferencia],"rol")==0)
			ptr="juegos.rol";
		else
			ptr=Conferencias[Conferencia];

        sprintf(str,"CONFERENCIA: %s\r\nTema: %s\r\nA: %s\r\n\r\nEn el mensaje %d de %s, %s dijo:\r\n\r\n",
                ptr,
                Subject+1,Xremit,
                Msg.num,Conferencias[Conferencia],Xremit);

        /* impide que se redibuje */
        SendMessage(h, WM_SETREDRAW, 0, 0L);

        SendMessage(h, EM_SETSEL, 0, 0L);
        SendMessage(h, EM_REPLACESEL, 0, (LONG)(char far *) str);

        /* coge el nmero de lneas */
        l=SendMessage(h, EM_GETLINECOUNT, 0, 0L);

        /* nmero de lneas que no quedarn quoteadas */
        lini=5;

        /* primer carcter */
        ini=0;

        /* pone el relojito */
        hc=SetCursor(LoadCursor(NULL, IDC_WAIT));

        for(n=0;n<l;n++)
        {
                if(lini)
                        lini--;
                else
                {
                        /* activa la seleccin */
                        SendMessage(h, EM_SETSEL, 0, MAKELONG(ini,ini));

                        /* reemplaza la seleccin por el smbolo de quote */
                        SendMessage(h, EM_REPLACESEL, 0, (LONG)(char far *) QUOTE_CHARS);
                }

                /* mximo de caracteres a leer */
                str[0]=0xFF;
                str[1]=0x00;

                /* coge la lnea (slo para saber cunto mide) */
                ini+=SendMessage(h, EM_GETLINE, (WORD) n, (LONG)(char far *) str)+2;
        }

        SendMessage(h, EM_SETSEL, 0, MAKELONG(ini,ini));
        SendMessage(h, EM_REPLACESEL, 0, (LONG)(char far *) "\r\n");

        /* se vuelve a habilitar el redraw */
        SendMessage(h, WM_SETREDRAW, 1, 0L);

		/* va al principio */
        SendMessage(h, EM_SETSEL, 0, 0L);
        SendMessage(h, EM_REPLACESEL, 0, (LONG)(char far *) "");

        /* restaura la flecha */
        SetCursor(hc);
}


int CargarLista(HWND hwnd)
/* carga en la lista las cabeceras */
{
        HWND h;
        char tmp[500];
        int i,d;
        struct tagind ti;
        char from [101];
        char to [101];
        char sub[101];
        int n;
        int t;
        int num;
        char forme;

        NumMsgs=0;

        h=GetDlgItem(hwnd, WAI_LISTA);
        if(!h)
                return(0);

        /* se vaca la lista */
        SendMessage(h, LB_RESETCONTENT, 0, 0L);

        /* si no hay conferencia... */
        if(Conferencia==-1)
                return(0);

        /* se abren los ficheros */
        if(Histo)
        {
                i=open(HISTO_IND, O_RDONLY|O_BINARY);
                d=open(HISTO_DAT, O_RDONLY|O_BINARY);
        }
        else
        {
                i=open(NUEVOS_IND, O_RDONLY|O_BINARY);
                d=open(NUEVOS_DAT, O_RDONLY|O_BINARY);
        }

        if(i==-1 || d==-1)
        {
                close(i);
                close(d);
                return(0);
        }

        /* se crea el fichero temporal */
        if((t=open(TMP_FILE, O_CREAT|O_TRUNC|O_WRONLY|O_BINARY,
                S_IREAD|S_IWRITE))==-1)
        {
                close(i);
                close(d);
                return(0);
        }

        num=0;

        /* bucle de lectura del ndice */
        while(TRUE)
        {
                /* se lee un tag del ndice */
                if(read(i, &ti, sizeof(ti))!=sizeof(ti))
                        break;

                /* si no es de esta conferencia, adis */
                if((ti.dat&MASK_CONF)!=Conferencia)
                {
                        num++;
                        continue;
                }

                /* si est borrado y es el histrico, no sale */
                if((ti.dat&MASK_BOR) && Histo)
                {
                        num++;
                        continue;
                }

                /* si ste mensaje vale, se guarda en el temporal */
                write(t,&num, sizeof(int));

                if(ti.offsub!=0xFFFF)
                {
                        /* se lee el subject */
                        lseek(d, (long)(ti.offset+ti.offsub), 0);
                        read(d, sub, 100);
                }
                else
                        sub[0]=0;

                /* quita caracteres sobrantes */
                for(n=0;sub[n]!='\n' && sub[n]!=0 && n<100;n++);
                sub[n]=0;

                if(ti.offfrom!=0xFFFF)
                {
                        /* se lee el from */
                        lseek(d, (long)(ti.offset+ti.offfrom), 0);
                        read(d, from, 100);
                }
                else
                        from[0]=0;

                /* quita caracteres sobrantes */
                for(n=0;from[n]!='@' && from[n]!=0 && from[n]!='\n' && n<100;n++);
                from[n]=0;

                if(ti.offto!=0xFFFF)
                {
                        /* se lee el to */
                        lseek(d, (long)(ti.offset+ti.offto), 0);
                        read(d, to, 100);
                }
                else
                        to[0]=0;

                /* quita caracteres sobrantes */
                for(n=0;to[n]!='@' && to[n]!=0 && to[n]!='\n' && n<100;n++);
                to[n]=0;

                SomeToAnsi(sub,sub);
                SomeToAnsi(to,to);
                SomeToAnsi(from,from);

                if(strcmp(Yo,from)==0 || strcmp(Yo,to)==0)
                        forme=187;
                else
                        forme=' ';

                /* se crea la cadena */
                sprintf(tmp,"%c%8s -> %8s:%s", forme, from, to, sub);

                /* aade un elemento a la lista */
                SendMessage(h, LB_ADDSTRING, 0, (LONG) (char far *) tmp);

                num++;
                NumMsgs++;
        }

        close(i);
        close(d);
        close(t);

		if(NumMsgs)
		{
			if(Mensaje>=(DWORD) NumMsgs)
				Mensaje=0;

			if(Mensaje==NO_MENSAJE)
				Mensaje=0;

			SendMessage(h, LB_SETCURSEL, (WORD) Mensaje, 0L);
		}

        return(NumMsgs);
}


void BuildFonts(HWND hwnd)
/* coge el handler del font actual y crea uno fixed */
{
        LOGFONT lf;
        short int t;
		char font[100];

		/* se lee la informacin Font de WAILER.INI */
		GetPrivateProfileString(APPGEN, "Font","MS Sans Serif,15", font, sizeof(font)-1, INI_FILE);

        /* coge el fuente proporcional */
        pFont=(HANDLE) SendDlgItemMessage(hwnd, WAI_TEXTO, WM_GETFONT, 0, 0L);

        /* coge los datos del fuente actual */
        GetObject(pFont, sizeof(lf), (LPSTR) &lf);

        strcpy(lf.lfFaceName, strtok(font, ","));
        lf.lfHeight=atoi(strtok(NULL, ","));

		pFont=CreateFontIndirect((LOGFONT FAR *) &lf);
		SendDlgItemMessage(hwnd, WAI_TEXTO, WM_SETFONT, pFont, TRUE);

		/* se cambia la gordura */
		t=lf.lfWeight;
		lf.lfWeight=400;

		tFont=CreateFontIndirect((LOGFONT FAR *) &lf);

        /* se modifican los datos: se define como fixed */
        lf.lfPitchAndFamily&=0x3;
        lf.lfPitchAndFamily|=FIXED_PITCH;
		lf.lfWeight=t;

        /* se crea */
        fFont=CreateFontIndirect((LOGFONT FAR *) &lf);
}


void SetUpToolBar(HWND hwnd)
/* pone a tono la barra de opciones */
{
        EnableWindow(GetDlgItem(hwnd, WAI_ESCRIBIR), !Escr);
        EnableWindow(GetDlgItem(hwnd, WAI_ATRAS), !Escr);
        EnableWindow(GetDlgItem(hwnd, WAI_ADELANTE), !Escr);
        EnableWindow(GetDlgItem(hwnd, WAI_AVA), !Escr);
        EnableWindow(GetDlgItem(hwnd, WAI_RET), !Escr);
        EnableWindow(GetDlgItem(hwnd, WAI_CONFE), !Escr);
        EnableWindow(GetDlgItem(hwnd, WAI_CORTAR), Escr);
        EnableWindow(GetDlgItem(hwnd, WAI_PEGAR), Escr);
}


long FAR PASCAL WndProc (HWND hwnd, WORD message, WORD wParam, LONG lParam)
/* procedimiento de ventana */
{
    DWORD l;
    FARPROC lpfnConfeProc;
    char strtmp[200];
    static int ya=0;
    RECT r;
    HDC hdc;
    int itmp;

    switch (message)
    {
    case WM_CREATE:
        /* pone el nombre a la ventana */
        SetWindowText(hwnd, szApp);

        break;

	case WM_PAINT:

		/* dibuja el relieve */

		/* coge el hdc y el tamao */
		hdc=GetDC(hwnd);
		GetClientRect(hwnd, (LPRECT) &r);

		/* llama dos veces para crearlo grueso */
		Rect3D(hdc, &r, 0);
		r.top--;
		r.left--;
		r.bottom++;
		r.right++;
		Rect3D(hdc, &r, 0);

		/* se libera */
		ReleaseDC(hwnd, hdc);

		break;

    case WM_SHOWWINDOW:

        /* si es la primera vez, carga la lista y el mensaje */
        if(!ya)
        {
                /* si la conferencia es vlida... */
                if(Conferencia!=-1)
                {
                        CargarLista(hwnd);

                        SetTexto(hwnd);
                }

                /* modifica el procedimiento de edicin */
                ChangeEditProcs(GetDlgItem(hwnd, WAI_TEXTO));

                /* crea los fonts */
                BuildFonts(hwnd);

                /* pone fuente fixed a la lista */
                SendDlgItemMessage(hwnd, WAI_LISTA, WM_SETFONT,
                        fFont, 0L);

				/* pone fuente fino a los ttulos */
				SendDlgItemMessage(hwnd, WAI_MSGTIT, WM_SETFONT,
						tFont, 0L);
				SendDlgItemMessage(hwnd, WAI_INFOTIT, WM_SETFONT,
						tFont, 0L);
				SendDlgItemMessage(hwnd, WAI_FECHA, WM_SETFONT,
						tFont, 0L);

                SetUpToolBar(hwnd);

                ya=1;
        }

        break;

    case WM_SETFOCUS:
        /* The Wailer recupera el foco */
        if(Escr)
                SetFocus(GetDlgItem(hwnd, WAI_TEXTO));

        break;

    case WM_KEYDOWN:
        /* pulsaciones */

        /* si se pulsa shift, los movimientos van para la lista */
        if(GetKeyState(VK_SHIFT)<0)
        {
                switch(wParam)
                {
                case VK_HOME:
                case VK_END:
                case VK_PRIOR:
                case VK_NEXT:
                case VK_UP:
                case VK_DOWN:
                        /* enva la tecla a la lista */
                        SendDlgItemMessage(hwnd, WAI_LISTA, WM_KEYDOWN,
                                wParam, 0L);
                        break;
                }
        }
        else
        {
                switch(wParam)
                {
                /* hot-keys de cambio de font */
                case VK_DIVIDE:
                case VK_MULTIPLY:

                        SendMessage(hwnd, WM_COMMAND, WAI_FONT, 0L);
                        break;

                /* se le mandan a la ventana de texto */
                case VK_UP:
                        SendDlgItemMessage(hwnd, WAI_TEXTO, WM_VSCROLL,
                                SB_LINEUP, 0L);
                        break;

                case VK_DOWN:
                        SendDlgItemMessage(hwnd, WAI_TEXTO, WM_VSCROLL,
                                SB_LINEDOWN, 0L);
                        break;

                case VK_LEFT:
                        SendDlgItemMessage(hwnd, WAI_TEXTO, WM_HSCROLL,
                                SB_LINEUP, 0L);
                        break;

                case VK_RIGHT:
                        SendDlgItemMessage(hwnd, WAI_TEXTO, WM_HSCROLL,
                                SB_LINEDOWN, 0L);
                        break;

                case VK_PRIOR:
                        SendDlgItemMessage(hwnd, WAI_TEXTO, WM_VSCROLL,
                                SB_PAGEUP, 0L);
                        break;

                case VK_NEXT:
                        SendDlgItemMessage(hwnd, WAI_TEXTO, WM_VSCROLL,
                                SB_PAGEDOWN, 0L);
                        break;

                case VK_HOME:
                        SendDlgItemMessage(hwnd, WAI_TEXTO, WM_HSCROLL,
                                SB_TOP, 0L);
                        break;

                case VK_END:
                        SendDlgItemMessage(hwnd, WAI_TEXTO, WM_HSCROLL,
                                SB_BOTTOM, 0L);
                        break;

                case VK_DELETE:
                case VK_BACK:
                        /* Del y Backspc: hotkey,s. de borrar */
                        SendMessage(hwnd, WM_COMMAND, WAI_BORRAR, 0L);
                        break;

                case VK_INSERT:
                        /* escribe un mensaje */
                        SendMessage(hwnd, WM_COMMAND, WAI_ESCRIBIR, 0L);
                        break;

                case VK_RETURN:
                        /* contesta un mensaje */
                        SendMessage(hwnd, WM_COMMAND, WAI_CONTESTAR, 0L);
                        break;

                case VK_ESCAPE:
                        /* cuadro de conferencias */
                        SendMessage(hwnd, WM_COMMAND, WAI_CONFE, 0L);
                        break;

                case VK_ADD:
                        /* adelante conferencia */
                        SendMessage(hwnd, WM_COMMAND, WAI_ADELANTE, 0L);
                        break;

                case VK_SUBTRACT:
                        /* atrs conferencia */
                        SendMessage(hwnd, WM_COMMAND, WAI_ATRAS, 0L);
                        break;
                }
        }
        break;

    case WM_COMMAND:
        /* botones */
        switch(wParam)
        {
        case WAI_LISTA:

                if(Escr)
                        SetFocus(GetDlgItem(hwnd, WAI_TEXTO));
                else
                switch(HIWORD(lParam))
                {
                case LBN_SELCHANGE:     /* seleccin de mensaje */
                        l=SendDlgItemMessage(hwnd,WAI_LISTA,
                        	LB_GETCURSEL,0,0L);

                        if(l!=LB_ERR && l!=Mensaje)
                        {
                                Mensaje=l;
                                SetTexto(hwnd);
                        }

                        /* devuelve el foco a la ventana */
                        SetFocus(hwnd);
                }

                break;

        case WAI_TEXTO:

                break;

        case WAI_BORRAR:

                if(!Escr)
                {
                        if(Conferencia==-1)
                                MessageBox(hwnd,
                                "No hay ninguna conferencia seleccionada.",
                                        szApp, MB_OK|MB_ICONEXCLAMATION);
                        else
                        if(Mensaje==NO_MENSAJE)
                                MessageBox(hwnd,
                                "No hay ningn mensaje seleccionado.",
                                        szApp, MB_OK|MB_ICONEXCLAMATION);
                        else
                        {
                                /* graba en disco el elemento */
                                DelMsg(MASK_BOR);

                                SetFocus(hwnd);

                                /* se limpia el texto */
                                SetInfo(hwnd);

                                /* enva un cursor abajo a la lista */
                                SendDlgItemMessage(hwnd, WAI_LISTA,
                                	WM_KEYDOWN, VK_DOWN, 0L);
                        }
                }
                else
                {
                        /* si se est en modo escritura, es cancelar */
                        Escr=0;

                        SetWindowText(GetDlgItem(hwnd, WAI_CONTESTAR),
                                "Contestar");
                        SetTexto(hwnd);

                        SetUpToolBar(hwnd);

                        /* devuelve el foco a la ventana */
                        SetFocus(hwnd);
                }

                break;

        case WAI_CONTESTAR:

                /* si se est en modo lectura */
                if(!Escr)
                {
                        if(Conferencia==-1)
                                MessageBox(hwnd,
                                "No hay ninguna conferencia seleccionada.",
                                        szApp, MB_OK|MB_ICONEXCLAMATION);
                        else
                        if(Mensaje==NO_MENSAJE)
                                MessageBox(hwnd,
                                "No hay ningn mensaje seleccionado.",
                                        szApp, MB_OK|MB_ICONEXCLAMATION);
                        else
                        {
                                /* activa el modo de escritura */
                                Escr=1;

                                SetWindowText(GetDlgItem(hwnd,
                                	WAI_CONTESTAR), "Enviar");
                                SetWindowText(GetDlgItem(hwnd,
                                	WAI_BORRAR), "Cancelar");
                                QuoteTexto(hwnd);

                                SetUpToolBar(hwnd);

                                /* hace activo al texto */
                                SetFocus(GetDlgItem(hwnd, WAI_TEXTO));
                        }
                }
                else
                {
                        /* enviar mensaje */
                        Escr=0;

                        /* escribe en disco el mensaje */
                        WriteMensaje(hwnd);

                        /* restablece el estado normal de los botones */
                        SetWindowText(GetDlgItem(hwnd, WAI_CONTESTAR),
                                "Contestar");
                        SetTexto(hwnd);

                        SetUpToolBar(hwnd);

                        /* devuelve el foco a la ventana */
                        SetFocus(hwnd);
                }

                break;

        case WAI_ESCRIBIR:
                if(Escr)
                        /* hace activo al texto */
                        SetFocus(GetDlgItem(hwnd, WAI_TEXTO));
                else
                if(Conferencia==-1)
                        MessageBox(hwnd,
                        "No hay ninguna conferencia seleccionada.",
                                szApp, MB_OK|MB_ICONEXCLAMATION);
                else
                {
                                /* activa el modo de escritura */
                                Escr=1;

                                SetWindowText(GetDlgItem(hwnd, WAI_CONTESTAR),
                                        "Enviar");
                                SetWindowText(GetDlgItem(hwnd, WAI_BORRAR),
                                        "Cancelar");

                                sprintf(strtmp,
                                "CONFERENCIA: %s\r\nTema: \r\nA: \r\n",
                                strcmp(Conferencias[Conferencia],"rol")==0?
                                "juegos.rol":Conferencias[Conferencia]);

                                SetWindowText(GetDlgItem(hwnd, WAI_TEXTO),
                                        strtmp);

                                SetUpToolBar(hwnd);

                                /* hace activo al texto */
                                SetFocus(GetDlgItem(hwnd, WAI_TEXTO));
                }

                break;

        case WAI_CONFE:
                if(Escr)
                        /* hace activo al texto */
                        SetFocus(GetDlgItem(hwnd, WAI_TEXTO));
                else
                {
                        /* llama al cuadro de dilogo */
                        lpfnConfeProc=MakeProcInstance(ConfeProc,hInst);
                        l=(DWORD) DialogBox(hInst,"WailerConf",
                                hwnd, lpfnConfeProc);
                        FreeProcInstance(lpfnConfeProc);

                        if(l)
                        {
                                /* se "desselecciona" el mensaje */
                                Mensaje=NO_MENSAJE;

                                /* se carga la lista de mensajes */
                                CargarLista(hwnd);

                                /* se define el texto */
                                SetTexto(hwnd);
                        }
                }
                break;

        case WAI_ATRAS:

                /* retrocede una conferencia */
                if(!Escr)
                {
                		itmp=Conferencia;

                        while(Conferencia>=0)
                        {
                                Conferencia--;
                                Mensaje=NO_MENSAJE;

                                if(!CargarLista(hwnd))
                                        continue;

                                break;
                        }

                        if(Conferencia==-1)
                        {
                        	Conferencia=itmp;
                        	CargarLista(hwnd);
                        }

                        SetTexto(hwnd);
                }

                SetFocus(hwnd);
                break;

        case WAI_ADELANTE:

                /* avanza una conferencia */
                if(!Escr)
                {
                		itmp=Conferencia;

                        while(Conferencia<NumConfes)
                        {
                                Conferencia++;
                                Mensaje=NO_MENSAJE;

                                if(!CargarLista(hwnd))
                                        continue;

                                break;
                        }

                        if(Conferencia==NumConfes)
                        {
                        	Conferencia=itmp;
                        	CargarLista(hwnd);
                        }

						SetTexto(hwnd);
                }

                SetFocus(hwnd);
                break;

        case WAI_ACERCA:

                /* llama al cuadro de dilogo */
                lpfnConfeProc=MakeProcInstance(AcercaDeProc,hInst);
                DialogBox(hInst,"AcercaDeWailer",
                        hwnd, lpfnConfeProc);
                FreeProcInstance(lpfnConfeProc);

                SetFocus(hwnd);
                break;

        case WAI_PRN:

                PrintMsg(GetDlgItem(hwnd,WAI_TEXTO));
                break;

        case WAI_AVA:

                /* avanzar: igual que un cursor derecha */
                SendDlgItemMessage(hwnd, WAI_LISTA, WM_KEYDOWN,
                        VK_RIGHT, 0L);
                break;

        case WAI_RET:

                /* retroceder: igual que un cursor izquierda */
                SendDlgItemMessage(hwnd, WAI_LISTA, WM_KEYDOWN,
                        VK_LEFT, 0L);
                break;

        case WAI_FONT:

                fontswitch++;
                if(fontswitch==3)
                	fontswitch=0;

                if(fontswitch==1)
                        SendDlgItemMessage(hwnd, WAI_TEXTO, WM_SETFONT,
                                fFont, TRUE);
                else
                if(fontswitch==2)
                		SendDlgItemMessage(hwnd, WAI_TEXTO, WM_SETFONT,
                				tFont, TRUE);
                else
                        SendDlgItemMessage(hwnd, WAI_TEXTO, WM_SETFONT,
                                pFont, TRUE);

                break;

        case WAI_CORTAR:

                if(Escr)
                        SendDlgItemMessage(hwnd, WAI_TEXTO, WM_CUT,
                        0, 0L);
                else
                        MessageBeep(0);

                break;

        case WAI_COPIAR:

                SendDlgItemMessage(hwnd, WAI_TEXTO, WM_COPY,
                        0, 0L);

                break;

        case WAI_PEGAR:

                if(Escr)
                SendDlgItemMessage(hwnd, WAI_TEXTO, WM_PASTE,
                        0, 0L);
                else
                        MessageBeep(0);

                break;

        case WAI_SALIR:

                SendMessage(hwnd, WM_CLOSE, 0, 0L);
                break;
        }
        break;

    case WM_DESTROY:

        EndWailer();

        PostQuitMessage (0);
        return(0);
    }

    return DefWindowProc (hwnd, message, wParam, lParam);
}


int PASCAL WinMain (HANDLE hInstance, HANDLE hPrevInstance,
                    LPSTR lpszCmdLine, int nCmdShow)
/* Funcin principal */
{
        HWND hwnd;
        MSG msg;
        WNDCLASS wndclass;

		if(*lpszCmdLine!=0)
			lstrcpy((LPSTR) INI_FILE, lpszCmdLine);

        if (hPrevInstance)
        {
                MessageBox(NULL,
                	"Ya se est ejecutando otra copia de The Wailer.",
                        szApp,MB_OK);
                return(0);
        }

        /* registra los botones de icono */
        IBReg(hInstance);

        hInst=hInstance;

        wndclass.style          = CS_HREDRAW | CS_VREDRAW;
		wndclass.lpfnWndProc    = K_WNDPROC WndProc;
        wndclass.cbClsExtra     = 0;
        wndclass.cbWndExtra     = DLGWINDOWEXTRA;
        wndclass.hInstance      = hInstance;
        wndclass.hIcon          = LoadIcon(hInstance, "Wailer");
        wndclass.hCursor        = LoadCursor (NULL, IDC_ARROW);
        wndclass.hbrBackground  = COLOR_BTNFACE + 1;
        wndclass.lpszMenuName   = NULL;
        wndclass.lpszClassName  = "WailerMain";

        RegisterClass (&wndclass);

        hwnd = CreateDialog (hInstance, "WailerMain", 0, NULL);

        InitWailer(hwnd);

        ShowWindow (hwnd, nCmdShow);

        while (GetMessage (&msg, NULL, 0, 0))
        {
                TranslateMessage (&msg);
                DispatchMessage (&msg);
        }

        return (msg.wParam);
}


