/*

	WINPRINT.C

	Rutinas de impresin desde Windows.

	(C) Angel Ortega 1993 Kaplan Development Software.

*/

HDC OpenPrn(void)
/* crea el contexto de dispositivo de impresin */
{
	static char szPrinter [80];
	char *szDevice, *szDriver, *szOutput ;

	GetProfileString ("windows", "device", ",,,", szPrinter, 80);

    if ((szDevice = strtok (szPrinter, "," ))!=NULL &&
		(szDriver = strtok (NULL,      ", "))!=NULL &&
		(szOutput = strtok (NULL,      ", "))!=NULL)
		return CreateDC (szDriver, szDevice, szOutput, NULL);
    else
		return (0);
}


void FormFeedPrn(HDC hdc)
/* expulsa una pgina */
{
	Escape(hdc,NEWFRAME,0,NULL,NULL);
}


void BeginPrn(HDC hdc, char * wrk)
/* comienza un documento */
{
	Escape(hdc,STARTDOC,strlen(wrk),wrk,NULL);
}



void TamPagPrn(HDC hdc, int * x, int * y)
/* coge el tamao de la hoja de la impresora en puntos */
{
	POINT p;

	Escape(hdc,GETPHYSPAGESIZE,NULL,NULL,(LPSTR) &p);

	*x=p.x;
	*y=p.y;
}


void ClosePrn(HDC hdc)
/* cierra la impresora */
{
	FormFeedPrn(hdc);

	Escape(hdc,ENDDOC,0,NULL,NULL);

	DeleteDC(hdc);
}
